"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _codeSurfer = require("code-surfer");

var _codeSurfer2 = _interopRequireDefault(_codeSurfer);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _mdxDeck = require("mdx-deck");

var _context = require("mdx-deck/dist/context");

var _Slide = require("mdx-deck/dist/Slide");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

exports.default = (0, _context.withDeck)((0, _Slide.withSlide)(function (_React$Component) {
  _inherits(_class2, _React$Component);

  function _class2() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, _class2);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = _class2.__proto__ || Object.getPrototypeOf(_class2)).call.apply(_ref, [this].concat(args))), _this), _this.handleKeyDown = function (e) {
      if (e.metaKey || e.ctrlKey || e.shiftKey || e.altKey) return;
      if (_this.props.deck.index !== _this.props.slide.index) return;
      var update = _this.props.deck.update;

      switch (e.key) {
        case "ArrowDown":
          e.preventDefault();
          update((0, _mdxDeck.incStep)(_this.props.steps || []));
          break;
        case "ArrowUp":
          e.preventDefault();
          update((0, _mdxDeck.decStep)());
          break;
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(_class2, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      document.body.addEventListener("keydown", this.handleKeyDown);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      document.body.removeEventListener("keydown", this.handleKeyDown);
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate() {
      return this.props.deck.index === this.props.slide.index;
    }
  }, {
    key: "render",
    value: function render() {
      var _props = this.props,
          code = _props.code,
          steps = _props.steps,
          title = _props.title,
          notes = _props.notes,
          theme = _props.theme,
          rest = _objectWithoutProperties(_props, ["code", "steps", "title", "notes", "theme"]);

      var _props$deck = this.props.deck,
          step = _props$deck.step,
          mode = _props$deck.mode;


      var stepZero = {
        range: [0, code.split("\n").length],
        notes: notes
      };

      var currentStep = step < 0 ? stepZero : steps[step] || steps[0];
      // const isOverview = mode === modes.overview;

      var stepTitle = currentStep.title || title;
      var anyNotes = notes || steps.some(function (s) {
        return s.notes;
      });

      return _react2.default.createElement(
        "div",
        {
          style: {
            height: "100vh",
            width: "100vw",
            background: theme && theme.plain.backgroundColor,
            color: theme && theme.plain.color,
            display: "flex",
            alignItems: "center",
            justifyContent: "center"
          }
        },
        _react2.default.createElement(
          "div",
          {
            style: {
              height: "100vh",
              display: "flex",
              flexDirection: "column"
            }
          },
          stepTitle && _react2.default.createElement(
            "h1",
            null,
            stepTitle
          ),
          _react2.default.createElement(
            "div",
            { style: { flex: 1, overflow: "hidden" }, key: "code" },
            _react2.default.createElement(_codeSurfer2.default, _extends({
              code: code,
              step: currentStep,
              theme: theme
            }, rest))
          ),
          anyNotes && _react2.default.createElement(
            "p",
            { style: { height: "50px" } },
            currentStep.notes || "\xA0"
          ),
          _react2.default.createElement("div", { style: { height: "35px" } })
        )
      );
    }
  }]);

  return _class2;
}(_react2.default.Component)));